package org.artifactory.metrics.framework;

import java.util.Map;

/**
 * Holds all feature adoption labels that are tracked as part of Feature Adoption.
 *
 * @author Asaf Zalcman
 */
public enum FeatureAdoptionLabels {
    SUBFEATURE_PACKAGE(Map.of("subfeature", "package")),
    SUBFEATURE_REMOTE_PACKAGE(Map.of("subfeature", "remote_package")),
    API(Map.of("api", "true")),
    EMPTY(Map.of());

    private final Map<String, String> labels;

    FeatureAdoptionLabels(Map<String, String> labels) {
        this.labels = labels;
    }

    public Map<String, String> labels() {
        return labels;
    }
}
