package org.artifactory.ph;

import org.artifactory.common.home.ArtifactoryHome;
import org.artifactory.common.property.ArtifactorySystemProperties;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import static org.mockito.Mockito.when;
import static org.testng.Assert.assertNotNull;

@Test
public class ArtifactoryPackageBeansConfigTest {

    @Mock
    private ArtifactoryHome home;
    @Mock
    private ArtifactorySystemProperties props;

    @BeforeMethod
    public void setUp() {
        MockitoAnnotations.openMocks(this);
        when(home.getArtifactoryProperties()).thenReturn(props);
        ArtifactoryHome.bind(home);
    }

    @AfterMethod
    public void teardown() {
        ArtifactoryHome.unbind();
    }

    @Test
    public void testGetConfProps() {
        assertNotNull(new ArtifactoryPackageBeansConfig().getConfProps());
    }

    @Test
    public void testPackageRepoService() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageRepoService(null, null));
    }

    @Test
    public void testPackageDownloadService() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageDownloadService(null, null));
    }

    @Test
    public void testPackageUploadService() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageUploadService(null, null));
    }

    @Test
    public void testPackageStorageInterceptorAdapter() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageStorageInterceptorAdapter(null, null, null));
    }

    @Test
    public void testPackageSecurityService() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageSecurityService(null, null));
    }

    @Test
    public void testPackageSearchServicePH() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageSearchArtifactService(null, null));
    }

    @Test
    public void testPackageSpecification() {
        assertNotNull(new ArtifactoryPackageBeansConfig().packageSpecification(null));
    }

    @Test
    public void testPackageArtifactEventListenerOSS() {
        assertNotNull(new ArtifactoryPackageBeansConfig.PackageOssConfig().packageArtifactEventListener());
    }

    @Test
    public void testPackageVirtualAdapterOSS() {
        assertNotNull(new ArtifactoryPackageBeansConfig.PackageOssConfig().packageVirtualAdapter());
    }

    @Test
    public void testPackageRepoIndexCalculatorServiceOSS() {
        assertNotNull(new ArtifactoryPackageBeansConfig.PackageOssConfig().packageRepoIndexCalculatorService());
    }

    @Test
    public void testPackageSpecificationAdapterOSS() {
        assertNotNull(new ArtifactoryPackageBeansConfig.PackageOssConfig().packageSpecificationAdapter());
    }
}