package org.artifactory.addon.observability;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;

import java.io.InputStream;
import java.util.Map;

/**
 * @author Andrey Tashlitsky
 */
@Getter
@ToString(callSuper = true)
public class UsageLogShippingInfo extends ObservabilityInfo {

    public static final String NODE_ID_FIELD = "nodeId";
    public static final String SERVICE_ID_FIELD = "serviceId";

    private final String nodeId;
    private final String serviceId;

    @Builder
    public UsageLogShippingInfo(String logName, String productName, String type, InputStream inputStream, String nodeId,
            String serviceId) {
        super(logName, productName, type, inputStream);
        this.nodeId = nodeId;
        this.serviceId = serviceId;
    }

    @Override
    public Map<String, String> getProperties() {
        return Map.of(
                LOG_NAME_FIELD, getLogName(),
                PRODUCT_NAME_FIELD, getProductName(),
                TYPE_FIELD, getType(),
                NODE_ID_FIELD, getNodeId(),
                SERVICE_ID_FIELD, getServiceId()
        );
    }
}
