package org.artifactory.entitlement;

public enum EntitlementType {
    LIVE_LOGS,
    BINARY_PROVIDER_DOWNLOAD_REDIRECT,
    CDN,
    ANONYMOUS_CDN,
    CHECKSUM_BASED_STORAGE_REPLICATION,
    EDGE, // identity
    COLD_STORAGE, //we are cold instance - identity
    RELEASE_BUNDLES_READ,
    RELEASE_BUNDLES_WRITE,
    ACCESS_FEDERATION,
    BINARY_PROVIDER_CUSTOM_ENDPOINT,
    JFXR,
    FEDERATED_REPOSITORY,
    COLD_STORAGE_CREATE,
    RETENTION_WEBHOOKS,
    SIGNED_URL,
    HA,
    PDN,
    JFRT, // artifactory that not edge or ice - identity
    MULTIPUSH_REPLICATION,
    EVENT_BASED_PULL_REPLICATION,
    TRACKER,
    REPLICATOR,
    LDAP,
    SAML,
    CROWD,
    OAUTH,
    BINARY_PROVIDER_RSH,
    MTLS,

    //those should be loading unless we have an edge license. replacement for @EdgeBlockedAddon
    REPO_REPLICATION,
    SMART_REMOTE_TARGET_FOR_EDGE,

    // this part will be deleted when entitlementService will be stable,
    EDGE_MIXED,
    RELEASE_BUNDLES_WRITE_MIX,
    BINARY_PROVIDER_DOWNLOAD_REDIRECT_MIX

}