package org.artifactory.rest.filter;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.ObjectWriter;
import com.fasterxml.jackson.databind.ser.FilterProvider;
import com.fasterxml.jackson.databind.ser.impl.SimpleFilterProvider;
import com.fasterxml.jackson.jaxrs.cfg.EndpointConfigBase;
import com.fasterxml.jackson.jaxrs.cfg.ObjectWriterInjector;
import com.fasterxml.jackson.jaxrs.cfg.ObjectWriterModifier;
import org.artifactory.api.jackson.util.TypeSpecificFilter;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerResponseContext;
import javax.ws.rs.container.ContainerResponseFilter;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.ext.Provider;
import java.io.IOException;

import static org.artifactory.api.jackson.util.TypeSpecificFilter.TYPE_SPECIFIC_FILTER;

@Provider
public class JsonMappingExceptionOnCollectionResponseFilter implements ContainerResponseFilter {
    @Override
    public void filter(ContainerRequestContext requestCtx, ContainerResponseContext responseCtx) throws IOException {
        ObjectWriterInjector.set(new ObjectWriterModifier() {

            @Override
            public ObjectWriter modify(EndpointConfigBase<?> endpoint, MultivaluedMap<String, Object> responseHeaders,
                    Object valueToWrite, ObjectWriter w, JsonGenerator g) {
                FilterProvider filterProvider =
                        new SimpleFilterProvider().addFilter(TYPE_SPECIFIC_FILTER, new TypeSpecificFilter());
                return w.with(filterProvider);
            }
        });
    }
}
